package reachability;

import java.util.ArrayList;

public class MC {
    private ArrayList<Integer> states = new ArrayList<Integer>();
    private ArrayList<Transition> transitions = new ArrayList<Transition>();
    private ArrayList<Double> probabilities = new ArrayList<Double>();
    
    /**
     * Constructor of class MC.
     */
    public MC(ArrayList<Integer> states, ArrayList<Transition> transitions, ArrayList<Double> probabilities)
    {
        for (int i = 0; i < states.size(); i++) {
            this.states.add(i, states.get(i));
        }
        for (int i = 0; i < transitions.size(); i++) {
            this.transitions.add(i, transitions.get(i));
            this.probabilities.add(i, probabilities.get(i));
        }
    }
    
    /**
     * Returns the states of this MC.
     * 
     * @return the states of this MC
     */
    public ArrayList<Integer> getStates()
    {
        return states;
    }
    
    /**
     * Returns the transitions of this MC.
     * 
     * @return the transitions of this MC
     */
    public ArrayList<Transition> getTransitions()
    {
        return transitions;
    }
    
    /**
     * Returns the probabilities of this MC.
     * 
     * @return the probabilities of this MC
     */
    public ArrayList<Double> getProbabilities()
    {
        return probabilities;
    }
}
