package reachability;

import java.util.ArrayList;

public class PVASS {
    private int dimension;
    private ArrayList<Integer> states = new ArrayList<Integer>();
    private ArrayList<Rule> rules = new ArrayList<Rule>();
    private ArrayList<Integer> weights = new ArrayList<Integer>();
    
    /**
     * Constructor of class PVASS.
     */
    public PVASS(int dimension, ArrayList<Integer> states, ArrayList<Rule> rules, ArrayList<Integer> weights)
    {
        this.dimension = dimension;
        for (int i = 0; i < states.size(); i++) {
            this.states.add(states.get(i));
        }
        this.rules.addAll(rules);
        this.weights.addAll(weights);
    }
    
    /**
     * Returns the dimension of this PVASS.
     * 
     * @return the dimension of this PVASS
     */
    public int getDimension()
    {
        return dimension;
    }
    
    /**
     * Returns the states of this PVASS.
     * 
     * @return the states of this PVASS
     */
    public ArrayList<Integer> getStates()
    {
        return states;
    }
    
    /**
     * Returns the rules of this PVASS.
     * 
     * @return the rules of this PVASS
     */
    public ArrayList<Rule> getRules()
    {
        return rules;
    }
    
    /**
     * Returns the weights of this PVASS.
     * 
     * @return the weights of this PVASS
     */
    public ArrayList<Integer> getWeights()
    {
        return weights;
    }
}
