package reachability;

import java.util.ArrayList;
import java.util.Random;
import java.util.Vector;
import edu.princeton.cs.algs4.*;
import Jama.*;

public class Reachability {
    
    public static final String ANSI_RESET = "\u001B[0m";
    public static final String ANSI_RED = "\u001B[31m";
    public static final String ANSI_BLUE = "\u001B[34m";

    public static void main(String[] args) {
        for (int dimension = 1; dimension <= 2; dimension++) {
            for (int numberOfStates = 2; numberOfStates <= 4; numberOfStates++) {
                for (int variety = 1; variety <= 10; variety++) {
                    ArrayList<Integer> states = new ArrayList<Integer>();
                    Vector<Integer> vector = new Vector<Integer>();
                    ArrayList<Rule> rules = new ArrayList<Rule>();
                    ArrayList<Integer> weights = new ArrayList<Integer>();
                    Random random = new Random();
                    int i, j;
                    for (i = 0; i < numberOfStates; i++) {
                        states.add(i);
                    }
                    for (i = 0; i < dimension; i++) {
                        vector.add(0);
                    }
                    for (i = 0; i < numberOfStates; i++) {
                        for (j = 0; j < dimension; j++) {
                            vector.set(j, (random.nextInt(3)-1));
                        }
                        rules.add(new Rule(i, vector, random.nextInt(numberOfStates)));
                    }
                    int numberOfRules = random.nextInt(numberOfStates*(numberOfStates-1))+1;
                    int state1, state2, auxiliaryVariable1;
                    for (i = 0; i < numberOfRules; i++) {
                        state1 = random.nextInt(numberOfStates);
                        for (j = 0; j < dimension; j++) {
                            vector.set(j, (random.nextInt(3) - 1));
                        }
                        state2 = random.nextInt(numberOfStates);
                        auxiliaryVariable1 = 0;
                        for (j = 0; j < rules.size(); j++) {
                            if (state1 == rules.get(j).getState1() && vector.equals(rules.get(j).getVector()) && state2 == rules.get(j).getState2()) {
                                auxiliaryVariable1 = -1;
                            }
                        }
                        if (auxiliaryVariable1 == 0) {
                            rules.add(new Rule(state1, vector, state2));
                        }
                    }
                    for (i = 0; i < rules.size(); i++) {
                        weights.add(i, (random.nextInt(10) + 1));
                    }
                    
                    PVASS s = new PVASS(dimension, states, rules, weights);
                    System.out.print("PVASS S rozmeru "+dimension+" = ("+states+", {");
                    for (i = 0; i < rules.size(); i++) {
                        System.out.print(rules.get(i));
                        if (i < rules.size()-1) {
                            System.out.print(", ");
                        }
                    }
                    System.out.println("}, "+weights+")");
                    Vector<Integer> vector1 = new Vector<Integer>();
                    for (i = 0; i < dimension; i++) {
                        vector1.add(1);
                    }
                    Configuration configurationP1 = new Configuration(0, vector1);
                    System.out.println("Konfiguracia p1 = "+configurationP1);
                    
                    Transition transition;
                    ArrayList<Transition> transitions = new ArrayList<Transition>();
                    double totalWeight, probability;
                    ArrayList<Double> probabilities1 = new ArrayList<Double>();
                    ArrayList<Double> probabilities2 = new ArrayList<Double>();
                    MC f;
                    Digraph g1;
                    TarjanSCC scc;
                    ArrayList<ArrayList<Integer>> sccs;
                    double[][] a;
                    int[] x;
                    double[][] b;
                    int k;
                    int l;
                    Matrix a2;
                    Matrix b2;
                    double[][] mi;
                    double change;
                    double[] trend = new double[dimension];
                    int bottom;
                    ArrayList<Rule> rules2 = new ArrayList<Rule>();
                    Vector<Integer> vectorOfZeros = new Vector<Integer>();
                    for (i = 0; i < dimension; i++) {
                        vectorOfZeros.add(i, 0);
                    }
                    EdgeWeightedDigraph g2;
                    int[][] botfins;
                    long auxiliaryVariable2;
                    BellmanFordSP sp;
                    boolean[] isDecreasing = new boolean[dimension];
                    boolean[] isDiverging = new boolean[dimension];
                    Vector<Integer> vector2 = new Vector<Integer>();
                    Vector<Integer> vector3 = new Vector<Integer>();
                    Configuration configurationQu, configurationQu2, configurationQz2;
                    VASS s2;
                    int numberOfStates2;
                    int auxiliaryVariable3 = 0;
                    
                    for (i = 0; i < s.getRules().size(); i++) {
                        auxiliaryVariable1 = 0;
                        for (j = 0; j < transitions.size(); j++) {
                            if (s.getRules().get(i).getState1() == transitions.get(j).getState1() && s.getRules().get(i).getState2() == transitions.get(j).getState2()) {
                                auxiliaryVariable1 = -1;
                            }
                        }
                        if (auxiliaryVariable1 == 0) {
                            transitions.add(new Transition(s.getRules().get(i).getState1(), s.getRules().get(i).getState2()));
                        }
                    }
                    for (i = 0; i < s.getRules().size(); i++) {
                        probabilities1.add(1.0);
                    }
                    for (i = 0; i < transitions.size(); i++) {
                        totalWeight = 0;
                        for (j = 0; j < s.getRules().size(); j++) {
                            if (transitions.get(i).getState1() == s.getRules().get(j).getState1()) {
                                totalWeight = totalWeight + s.getWeights().get(j);
                            }
                        }
                        probability = 0;
                        for (j = 0; j < s.getRules().size(); j++) {
                            if (transitions.get(i).getState1() == s.getRules().get(j).getState1() && transitions.get(i).getState2() == s.getRules().get(j).getState2()) {
                                probabilities1.set(j, s.getWeights().get(j) / totalWeight);
                                probability = probability + probabilities1.get(j);
                            }
                        }
                        probabilities2.add(i, probability);
                    }
                    f = new MC(states, transitions, probabilities2);
                    g1 = new Digraph(f.getStates().size());
                    for (i = 0; i < f.getTransitions().size(); i++) {
                        g1.addEdge(f.getTransitions().get(i).getState1(),f.getTransitions().get(i).getState2());
                    }
                    scc = new TarjanSCC(g1);
                    sccs = new ArrayList<ArrayList<Integer>>();
                    for (i = 0; i < scc.count(); i++) {
                        sccs.add(i, new ArrayList<Integer>());
                    }
                    for (int v = 0; v < g1.V(); v++) {
                        sccs.get(scc.id(v)).add(v);
                    }
                    int factorialOfDimension = 1;
                    for (i = 2; i <= dimension; i++) {
                        factorialOfDimension *= i;
                    }
                    int c;
                    
                    for (i = 0; i < sccs.size(); i++) {
                        auxiliaryVariable1 = 0;
                        for (j = 0; j < f.getTransitions().size(); j++) {
                            if (sccs.get(i).contains(f.getTransitions().get(j).getState1()) && !sccs.get(i).contains(f.getTransitions().get(j).getState2())) {
                                auxiliaryVariable1 = -1;
                            }
                        }
                        if (auxiliaryVariable1 == 0) {
                            a = new double[sccs.get(i).size() + 1][sccs.get(i).size()];
                            x = new int[sccs.get(i).size()];
                            b = new double[sccs.get(i).size() + 1][1];
                            System.out.print("BSCC : ");
                            for (j = 0; j < sccs.get(i).size(); j++) {
                                a[0][j] = 1;
                                x[j] = sccs.get(i).get(j);
                                System.out.print(sccs.get(i).get(j));
                                if (j < sccs.get(i).size()-1) System.out.print(", ");
                            }
                            System.out.println();
                            b[0][0] = 1;
                            for (j = 0; j < sccs.get(i).size(); j++) {
                                for (k = 0; k < x.length; k++) {
                                    auxiliaryVariable1 = 0;
                                    if (sccs.get(i).get(j) == x[k]) {
                                        a[j+1][k] = 1;
                                        auxiliaryVariable1 = 1;
                                    }
                                    for (l = 0; l < f.getTransitions().size(); l++) {
                                        if (sccs.get(i).get(j) == f.getTransitions().get(l).getState2() && x[k] == f.getTransitions().get(l).getState1()) {
                                            if (f.getTransitions().get(l).getState1() == f.getTransitions().get(l).getState2()) {
                                                a[j+1][k] = a[j+1][k] - f.getProbabilities().get(l);
                                            } else {
                                                a[j+1][k] = - f.getProbabilities().get(l);
                                            }
                                            auxiliaryVariable1 = 1;
                                        }
                                    }
                                    if (auxiliaryVariable1 == 0) {
                                        a[j+1][k] = 0;
                                    }
                                }
                                b[j+1][0] = 0;
                            }
                            a2 = new Matrix(a);
                            b2 = new Matrix(b);
                            mi = a2.solve(b2).getArray();
                            for (j = 0; j < dimension; j++) {
                                trend[j] = 0;
                                for (k = 0; k < sccs.get(i).size(); k++) {
                                    change = 0;
                                    for (l = 0; l < s.getRules().size(); l++) {
                                        if (sccs.get(i).get(k) == s.getRules().get(l).getState1()) {
                                            change = change + probabilities1.get(l) * s.getRules().get(l).getVector().get(j);
                                        }
                                    }
                                    trend[j] = trend[j] + mi[k][0] * change;
                                }
                                System.out.println("Trend["+j+"] = "+trend[j]);
                            }
                            bottom = sccs.get(i).size();
                            rules2.clear();
                            for (j = 0; j < s.getRules().size(); j++) {
                                if (sccs.get(i).contains(s.getRules().get(j).getState1()) && sccs.get(i).contains(s.getRules().get(j).getState2())) {
                                    rules2.add(new Rule(sccs.get(i).indexOf(s.getRules().get(j).getState1()), s.getRules().get(j).getVector(), sccs.get(i).indexOf(s.getRules().get(j).getState1())));
                                }
                            }
                            for (j = 0; j < sccs.get(i).size(); j++) {
                                rules2.add(new Rule(j, vectorOfZeros, bottom));
                            }
                            g2 = new EdgeWeightedDigraph(sccs.get(i).size()+1);
                            botfins = new int[dimension][sccs.get(i).size()];
                            auxiliaryVariable1 = 0;
                            for (j = 0; j < dimension; j++) {
                                for (k = 0; k < rules2.size(); k++) {
                                    g2.addEdge(new DirectedEdge(rules2.get(k).getState1(), rules2.get(k).getState2(), rules2.get(k).getVector().get(j)));
                                }
                                auxiliaryVariable2 = 0;
                                for (k = 0; k < sccs.get(i).size(); k++) {
                                    sp = new BellmanFordSP(g2, k);
                                    if (sp.hasNegativeCycle()) {
                                        botfins[j][k] = -1;
                                        auxiliaryVariable2 = -1;
                                    } else {
                                        botfins[j][k] = (int) Math.abs(sp.distTo(bottom)) + 1;
                                    }
                                    System.out.println("Botfin pozicia "+j+", stav "+sccs.get(i).get(k)+": "+botfins[j][k]);
                                }
                                if (auxiliaryVariable2 == -1) {
                                    isDecreasing[j] = true;
                                } else {
                                    isDecreasing[j] = false;
                                }
                                if (trend[j] > 0 || (trend[j] == 0 && isDecreasing[j] == false)) {
                                    isDiverging[j] = true;
                                } else {
                                    isDiverging[j] = false;
                                    auxiliaryVariable1 = -1;
                                }
                            }
                            
                            if (auxiliaryVariable1 == 0) {
                                rules2.clear();
                                for (j = 0; j < rules.size(); j++) {
                                    if (sccs.get(i).contains(rules.get(j).getState1()) && sccs.get(i).contains(rules.get(j).getState2())) rules2.add(rules.get(j));
                                }
                                s2 = new VASS(dimension, sccs.get(i), rules2);
                                System.out.print("VASS S rozmeru "+dimension+" = ("+sccs.get(i)+", {");
                                for (j = 0; j < rules2.size(); j++) {
                                    System.out.print(rules2.get(j));
                                    if (j < rules2.size()-1) {
                                        System.out.print(", ");
                                    }
                                }
                                System.out.println("})");
                                numberOfStates2 = sccs.get(i).size();
                                c = (int) (Math.pow(numberOfStates2, 2)+Math.pow(2*numberOfStates2+1, dimension)*(Math.pow(dimension, 2)*factorialOfDimension*Math.pow(numberOfStates2, 2)+2*Math.pow(dimension, 3)*Math.pow(factorialOfDimension, 2)*Math.pow(numberOfStates2, 4)*Math.pow((2*numberOfStates2+1), dimension)));
                                for (j = 0; j < dimension; j++) {
                                    if (trend[j]>0) {
                                        vector2.add(j, c);
                                        vector3.add(j, c+1);
                                    } else {
                                        vector2.add(j, botfins[j][0]);
                                        vector3.add(j, botfins[j][0]);
                                    }
                                }
                                configurationQu2 = new Configuration(sccs.get(i).get(0), vector2);
                                configurationQz2 = new Configuration(sccs.get(i).get(0), vector3);
                                System.out.println("Konfiguracia qu = " + configurationQu2);
                                System.out.println("Konfiguracia qz = " + configurationQz2);
                                System.out.println("Zistovanie pokrytelnosti qz z qu:");
                                if (s2.coverability1(configurationQu2, configurationQz2)) {
                                    System.out.println(ANSI_BLUE + "true" + ANSI_RESET);
                                    System.out.println("Zistovanie pokrytelnosti qu z pv:");
                                    if (s2.coverability2(configurationP1, configurationQu2)) {
                                        System.out.println(ANSI_BLUE + "true" + ANSI_RESET);
                                        auxiliaryVariable3 = 1;
                                        break;
                                    }
                                }
                                vector2.clear();
                                vector3.clear();
                            }
                        }
                    }
                    if (auxiliaryVariable3 == 0) {
                        System.out.println(ANSI_RED + "false" + ANSI_RESET);
                    }
                    System.out.println();
                }
            }
        }
    }
}