package reachability;

import java.util.Vector;

public class Rule {
    private final int state1;
    private final Vector<Integer> vector = new Vector<Integer>();
    private final int state2;
    
    /**
     * Constructor of class Rule.
     */
    public Rule(int state1, Vector<Integer> vector, int state2) {
        this.state1 = state1;
        this.vector.addAll(vector);
        this.state2 = state2;
    }
    
    /**
     * Returns the state 1 of this rule.
     * 
     * @return the state 1 of this rule
     */
    public int getState1() {
        return state1;
    }
    
    /**
     * Returns the vector of this rule.
     * 
     * @return the vector of this rule
     */
    public Vector<Integer> getVector() {
        return vector;
    }
    
    /**
     * Returns the state 2 of this rule.
     * 
     * @return the state 2 of this rule
     */
    public int getState2() {
        return state2;
    }
    
    /**
     * Returns the string containing the state 1, the vector and the state 2 of this configuration.
     * 
     * @return the string
     */
    @Override
    public String toString() {
        return "(" + state1 + ", " + vector + ", " + state2 + ")";
    }
}