package reachability;

import java.util.Vector;

public class Tuple {
    private final Configuration configuration;
    private final Vector<Integer> vector = new Vector<Integer>();
    
    /**
     * Constructor of class Transition.
     */
    public Tuple(Configuration configuration, Vector<Integer> vector) {
        this.configuration = new Configuration(configuration.getState(), configuration.getVector());
        this.vector.addAll(vector);
    }
    
    /**
     * Returns the configuration of this tuple.
     * 
     * @return the configuration of this tuple
     */
    public Configuration getConfiguration() {
        return configuration;
    }
    
    /**
     * Returns the vector of this tuple.
     * 
     * @return the vector of this tuple
     */
    public Vector<Integer> getVector() {
        return vector;
    }
    
    /**
     * Returns the string containing the configuration and the vector of this tuple.
     * 
     * @return the string
     */
    @Override
    public String toString() {
        return "(" + configuration + ", " + vector + ")";
    }
}